/*
 
 Copyright (C) 2010 Timo Lassmann <timolassmann@gmail.com>
 
 This file is part of delve.
 
 Delve is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 Delve is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Delve.  If not, see <http://www.gnu.org/licenses/>.
 
 */


#include "interface.h"
#include "seed.h"
#include "core.h"
#include "scoreboard.h"

int validate_bpm_sse(struct qs_struct* qs,int* assignment,unsigned char* t,int n,int num,long int offset)
{
	int i,j;
	int len = 0;
	struct seq_info* si = 0;
	unsigned long int new; 
	unsigned int _MM_ALIGN16 nuc[16];
	int _MM_ALIGN16 positions[4];
	int _MM_ALIGN16 errors[4];
	
	unsigned int _MM_ALIGN16 lengths[4];
	
	__m128i VP,VN,D0,HN,HP,X,MASK,K,NOTONE,POS,diff,zero,one;
	__m128i* nuc_p;
	__m128i xmm1,xmm2;
	//long int MASK = 0;
	
	for(i = 0; i < 16;i++){
		nuc[i] = 0ul;
	}
	
	for(i = 0; i < num;i++){
		si = qs->seq_info[abs(assignment[i])];
		len = si->len;
		if(len > 31){
			len = 31;
		}
		
		lengths[i] = len;
		
		
		if(assignment[i] >= 0){
			for(j = 0; j < len;j++){
				nuc[((int)(si->seq[j] & 0x3u) << 2) + i] |=  (1ul << (unsigned long int)(len-1-j));
	//			fprintf(stderr,"%c",si->seq[j]+65);
			}
		}else{
			for(j = 0; j < len;j++){
				nuc[((int)(si->reverse_seq[j] & 0x3u) << 2) + i] |=  (1ul << (unsigned long int)(len-1-j));
	//			fprintf(stderr,"%c",si->reverse_seq[j] + 65);
			}
		}
	//	fprintf(stderr,"\n" );
	}
	nuc_p = (__m128i*) nuc;
	//S = _mm_set1_epi32(0);
	zero = _mm_set1_epi32(0);
	one = _mm_set1_epi32(1);
	diff =  _mm_load_si128 ( (__m128i*) lengths );  // _mm_set1_epi32(m);
	VP =  _mm_set1_epi32(0xFFFFFFFFu);
	VN =  _mm_set1_epi32(0); 
	NOTONE =  _mm_set1_epi32(0xFFFFFFFF);
	K =  _mm_set1_epi32(0x7FFFFFFF);
	POS = _mm_set1_epi32(0);
	
	//VP = 0xFFFFFFFFFFFFFFFFul;
	//VN = 0ul;
	
	for(i = 0; i< 4;i++){
		lengths[i]--;
		lengths[i] = 1 << lengths[i];
	//	fprintf(stderr,"%d	%d	LEN:%d\n",i,num,lengths[i]);
	}
	
	// m--;
	MASK =  _mm_load_si128 ( (__m128i*) lengths ); //  _mm_set1_epi32(1ul << m);
	for(i = 0; i < n ;i++){
		//fprintf(stderr,"%c",*t + 65);
		X = _mm_or_si128 (*(nuc_p +( (int)(*t)  & 0x3u) ) , VN);
		//X = (B[(int) *t] | VN);
		xmm1 = _mm_and_si128(X, VP);
		xmm2 = _mm_add_epi32(VP ,xmm1);
		xmm1 = _mm_xor_si128 (xmm2, VP);
		D0 = _mm_or_si128(xmm1, X);
		//D0 = ((VP+(X&VP)) ^ VP) | X ;
		HN = _mm_and_si128(VP, D0);
		//HN = VP & D0;
		xmm1 = _mm_or_si128(VP, D0);
		xmm2 = _mm_andnot_si128 (xmm1,NOTONE);
		HP = _mm_or_si128(VN, xmm2);
		//HP = VN | ~(VP | D0);
		X = _mm_slli_epi32(HP,1);
		//X = HP << 1ul;
		VN = _mm_and_si128(X, D0);
		//VN = X & D0;
		xmm1 = _mm_slli_epi32(HN,1);
		xmm2 = _mm_or_si128(X, D0);
		xmm2 = _mm_andnot_si128 (xmm2,NOTONE);
		VP = _mm_or_si128(xmm1, xmm2);
		//VP = (HN << 1ul) | ~(X | D0);
		xmm1 = _mm_and_si128(HP, MASK);
		xmm2 = _mm_cmpgt_epi32(xmm1, zero);
		diff = _mm_add_epi32(diff , _mm_and_si128( xmm2, one));
		//diff += (HP & MASK) >> m;
		xmm1 = _mm_and_si128(HN, MASK);
		xmm2 = _mm_cmpgt_epi32(xmm1, zero);
		diff = _mm_sub_epi32(diff,  _mm_and_si128( xmm2, one));
		//diff -= (HN & MASK) >> m;
		xmm1 = _mm_cmplt_epi32(diff, K);
		xmm2 = _mm_and_si128(xmm1, diff);
		K = _mm_or_si128(xmm2, _mm_andnot_si128  (xmm1,K));
		xmm2 = _mm_and_si128(xmm1, _mm_set1_epi32(i));
		POS = _mm_or_si128(xmm2, _mm_andnot_si128  (xmm1,POS));
		t--;
	}
	//fprintf(stderr,"\n");
	_mm_store_si128 ((__m128i*) positions, POS);
	//fprintf(stderr,"%d	%d	%d	%d	",out1[0],out1[1],out1[2],out1[3]);
	_mm_store_si128 ((__m128i*) errors, K);
	//fprintf(stderr,"%d	%d	%d	%d\n",out2[0],out2[1],out2[2],out2[3]);
	
	for(i = 0; i < num;i++){
		si = qs->seq_info[abs(assignment[i])];
		//len = si->len;
		//lengths[i] = len;
	//	fprintf(stderr,"%d	%d	%d	%d	%d\n",  assignment[i] , si->len,num,out2[i],out1[i] + offset);
		if(assignment[i] >= 0){
			new = ((unsigned long int)(si->len - errors[i])) << 56ul;
			new |= ((unsigned long int) ((unsigned long int)offset - (unsigned long int) positions[i]) << 1ul);
			BinaryInsertionSortOne(si->match_units,LIST_STORE_SIZE ,new);
		}else{
			new = ((unsigned long int)(si->len - errors[i])) << 56ul;
			new |= ((unsigned long int) ((unsigned long int) offset - (unsigned long int) positions[i]) << 1ul);
			new |= 1ul ;
			BinaryInsertionSortOne(si->match_units,LIST_STORE_SIZE ,new);
		}
		
	}
	return 1;
}

unsigned long int validate_bpm(unsigned char* t,unsigned char* p,int n,int m,long int offset)
{
	unsigned long int B[4];
	
	if(m > 64){
		m = 64;
	}
	
	
	int diff = m;
	long int c;
	int i;
	int k = 256;
	register unsigned long int VP,VN,D0,HN,HP,X;
	long int MASK = 0;
	for(i = 0; i < 4;i++){
		B[i] = 0ul;
	}
	
	for(i = 0; i < m;i++){
		B[(int)(p[i] &0x3u)] |= (1ul << (unsigned long int)(m-1-i));
	}
	c = 0ul;
	VP = 0xFFFFFFFFFFFFFFFFul;
	VN = 0ul;
	m--;
	MASK = 1ul << m;
	for(i = 0; i < n;i++){
		X = (B[ (int)(*t  & 0x3u)] | VN);
		D0 = ((VP+(X&VP)) ^ VP) | X ;
		HN = VP & D0;
		HP = VN | ~(VP | D0);
		X = HP << 1ul;
		VN = X & D0;
		VP = (HN << 1ul) | ~(X | D0);
		diff += (HP & MASK) >> m;
		diff -= (HN & MASK) >> m;
		if(diff < k){
			k = diff;
			c = i;			
		}
		t--;
	}
	return (((unsigned long int) (m+1 -k)) << 56ul ) | ((unsigned long int)(( offset - c ) << 1ul));
}



unsigned long int validate_bpm_pre(unsigned char* t,unsigned long int* B,int n,int m,long int offset)
{
	//unsigned long int B[4];
	int diff = m;
	long int c;
	int i;
	int k = 256;
	register unsigned long int VP,VN,D0,HN,HP,X;
	long int MASK = 0;
	//for(i = 0; i < 4;i++){
	//	B[i] = 0ul;
	//}
	
	//for(i = 0; i < m;i++){
	//	B[(int)(p[i] &0x3u)] |= (1ul << (unsigned long int)(m-1-i));
	//}
	c = 0ul;
	VP = 0xFFFFFFFFFFFFFFFFul;
	VN = 0ul;
	m--;
	MASK = 1ul << m;
	for(i = 0; i < n;i++){
		X = (B[ (int)(*t  & 0x3u)] | VN);
		D0 = ((VP+(X&VP)) ^ VP) | X ;
		HN = VP & D0;
		HP = VN | ~(VP | D0);
		X = HP << 1ul;
		VN = X & D0;
		VP = (HN << 1ul) | ~(X | D0);
		diff += (HP & MASK) >> m;
		diff -= (HN & MASK) >> m;
		if(diff < k){
			k = diff;
			c = i;			
		}
		t--;
	}
	return (((unsigned long int) (m+1 -k)) << 56ul ) | ((unsigned long int)(( offset - c ) << 1ul));
}




unsigned long int bpm(const unsigned char* t,const unsigned char* p,int n,int m)
{
	register unsigned long int i;//,c;
	unsigned long int diff;
	unsigned long int B[5];
	if(m > 64){
		m = 64;
	}
	
	unsigned long int k = m;
	//static int counter = 0;
	register unsigned long int VP,VN,D0,HN,HP,X;
	
	long int MASK = 0;
	//c = 0;
	
	diff = m;
	
	for(i = 0; i < 5;i++){
		B[i] = 0;
	}
	
	for(i = 0; i < m;i++){
		B[(int)(p[i] & 0x3)] |= (1ul << i);
	}
		
	//c = 0;
	VP = 0xFFFFFFFFFFFFFFFFul;
	VN = 0ul;
	m--;
	MASK = 1ul << m;
	for(i = 0; i < n;i++){
		X = (B[(int)(t[i] &0x3)  ] | VN);
		D0 = ((VP+(X&VP)) ^ VP) | X ;
		HN = VP & D0;
		HP = VN | ~(VP | D0);
		X = HP << 1ul;
		VN = X & D0;
		VP = (HN << 1ul) | ~(X | D0);
		diff += (HP & MASK) >> m;
		diff -= (HN & MASK) >> m;
		if(diff < k){
			k = diff;
			
		}
	}
	return k;
}


unsigned int bpm6(unsigned char* t,unsigned char* p,int n,int m)
{
	int i;//,c;
	unsigned long int diff;
	unsigned long int B[6];
	if(m > 64){
		m = 64;
	}
	
	unsigned int k = m;
	//static int counter = 0;
	register unsigned long int VP,VN,D0,HN,HP,X;
	
	long int MASK = 0;
	//c = 0;
	
	diff = m;
	
	for(i = 0; i < 6;i++){
		B[i] = 0;
	}
	
	for(i = 0; i < m;i++){
		B[(int)p[i]] |= (1 <<(unsigned long int) i);
	}
	
	//c = 0;
	VP = 0xFFFFFFFFFFFFFFFFul;
	VN = 0;
	m--;
	MASK = 1ul << m;
	for(i = 0; i < n;i++){
		X = (B[(int)t[i]] | VN);
		D0 = ((VP+(X&VP)) ^ VP) | X ;
		HN = VP & D0;
		HP = VN | ~(VP | D0);
		X = HP << 1ul;
		VN = X & D0;
		VP = (HN << 1ul) | ~(X | D0);
		diff += (HP & MASK) >> m;
		diff -= (HN & MASK) >> m;
		if(diff < k){
			k = (unsigned int) diff;
			
		}
	}
	return k;
}


unsigned int* aln_scores()
{
	FILE *file = 0;
	unsigned int* aln_scores = 0;
	unsigned char* a = 0;
	unsigned char* b = 0;
	unsigned int i,j,k;
	a = malloc(sizeof(unsigned char)* 8);
	b = malloc(sizeof(unsigned char)* 8);
	
	aln_scores = malloc(sizeof(unsigned int)* 134217728);
	if((file = fopen("8_on_8.bin","rb"))){
		fprintf(stderr,"Reading index....\n");
		fread(aln_scores, sizeof(unsigned int),134217728 , file);
		fclose(file);
	}else{
		fprintf(stderr,"Built index....\n");
		if ((file = fopen("8_on_8.bin", "wb")) == NULL){
			fprintf(stderr,"can't open output\n");
			exit(-1);
		}
		for(i = 0; i < 134217728;i++){
			aln_scores[i] = 0u;
		}
		for(i = 0; i < 65536;i++){
			a[0] = (i >> 14) & 0x3;
			a[1] = (i >> 12) & 0x3;
			a[2] = (i >> 10) & 0x3;
			a[3] = (i >> 8) & 0x3;
			a[4] = (i >> 6) & 0x3;
			a[5] = (i >> 4) & 0x3;
			a[6] = (i >> 2) & 0x3;
			a[7] = i  & 0x3;
			
			for(j = 0; j < 65536;j++){
				b[0] = (j >> 14) & 0x3;
				b[1] = (j >> 12) & 0x3;
				b[2] = (j >> 10) & 0x3;
				b[3] = (j >> 8) & 0x3;
				b[4] = (j >> 6) & 0x3;
				b[5] = (j >> 4) & 0x3;
				b[6] = (j >> 2) & 0x3;
				b[7] = j &  0x3;
				k = bpm_small(a, b, 8, 8);
				
				/*for(c = 0;c < 8;c++){
				 fprintf(stderr,"%c",a[c] + 65);
				 }
				 fprintf(stderr,"\n");
				 for(c = 0;c < 8;c++){
				 fprintf(stderr,"%c",b[c] + 65);
				 }
				 fprintf(stderr,"	%d\n",k);*/
				if(k <= 1){
					k = (i << 16u) | j;
					aln_scores[k >> 5u] |= (1u << (k & 0x1Fu));
				}
			}
			if(i % 256 == 0){
				fprintf(stderr,"\r%8.0f percent done",(double)i /(double)65536 * 100);
			}
		}
		fprintf(stderr,"\n");
		
		fwrite(aln_scores, sizeof(unsigned int),134217728,file);
		fclose(file);
	}
	free(a);
	free(b);
	return aln_scores;
}


int bpm_small(unsigned char* t,unsigned char* p,int n,int m)
{
	int i,k;
	int diff;
	unsigned int B[4];
	//static int counter = 0;
	register unsigned int VP,VN,D0,HN,HP,X;
	
	int MASK = 0;
	//c = 0;
	
	diff = m;
	
	for(i = 0; i < 4;i++){
		B[i] = 0;
	}
	
	for(i = 0; i < m;i++){
		B[(int)p[i]] |= (1 <<(unsigned int) i);
	}
	//c = 0;
	VP = 0xFFFFFFFFu;
	VN = 0;
	k = m;
	m--;
	MASK = 1u << m;
	//fprintf(stderr,"MASK:%d\n",(int)MASK);
	for(i = 0; i < n;i++){
		X = (B[(int)t[i]] | VN);
		D0 = ((VP+(X&VP)) ^ VP) | X ;
		HN = VP & D0;
		HP = VN | ~(VP | D0);
		X = HP << 1u;
		VN = X & D0;
		VP = (HN << 1u) | ~(X | D0);
		diff += (HP & MASK) >> m;
		diff -= (HN & MASK) >> m;
		if(diff < k){
			k = diff;
		}
		
	}
	return k;
}






