/*
 
 Copyright (C) 2010 Timo Lassmann <timolassmann@gmail.com>
 
 This file is part of delve.
 
 Delve is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 Delve is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Delve.  If not, see <http://www.gnu.org/licenses/>.
 
 */

#define PSEUDO_CONSTANT_GENOME 0

int phmm_controller(struct db* db,struct parameters* param);
int read_sam_chunk(struct read_info** ri,struct db* db,struct parameters* param,FILE* file);

struct read_info** add_k(struct read_info** ri, struct db* db,int n);
int byg_end(const  char* pattern,const  char*text);

struct hmm* run_pHMM(struct hmm* localhmm,struct read_info** ri,struct db* db,struct parameters* param,int size);


struct read_info** score_alignments(struct read_info** ri, struct hmm* hmm, struct db* db,struct parameters* param, int n);
int realign_sam(struct db* db,struct parameters* param);
struct read_info** realign_alignments(struct read_info** ri, struct db* db,struct parameters* param, int n);


int post_phmm_controller(struct db* db,struct parameters* param);
struct read_info** add_uniform_prior(struct read_info** ri, int n);
struct hmm* run_post_pHMM(struct hmm* localhmm,struct read_info** ri,struct db* db,struct parameters* param,int size);


int post_phmm_controller(struct db* db,struct parameters* param);
struct read_info** get_posteriors(struct read_info** ri, struct hmm* hmm, struct db* db,struct parameters* param, int n, struct genome_probabilities* gp);

struct read_info** run_score_alignments(struct hmm* hmm,struct read_info** ri,struct db* db,struct parameters* param,int size);

void* do_score_alignments_thread(void *threadarg);

void print_bedgraphs( struct db* db,struct parameters* param, struct genome_probabilities* gp,int size);

void print_samheader(struct db* db,struct parameters* param);

struct rescue_probabilities* init_rp(unsigned int len,unsigned int block_len);
struct rescue_probabilities* update_rp(struct rescue_probabilities* rp, struct read_info** ri,unsigned int len,unsigned int block_len,int n,int up, float lib_size);
struct read_info** set_local_prob(struct rescue_probabilities* rp, struct read_info** ri,unsigned int len,unsigned int block_len,int n);
void free_rp(struct rescue_probabilities* rp);



